# Client

Manages a collection of client connections.


```pony
actor tag Client
```

## Constructors

### create

```pony
new tag create(
  auth: (AmbientAuth val | NetAuth val | TCPAuth val | 
    TCPConnectAuth val),
  sslctx: (SSLContext val | None val) = reference,
  pipeline: Bool val = true)
: Client tag^
```
#### Parameters

*   auth: ([AmbientAuth](builtin-AmbientAuth) val | [NetAuth](net-NetAuth) val | [TCPAuth](net-TCPAuth) val | 
    [TCPConnectAuth](net-TCPConnectAuth) val)
*   sslctx: ([SSLContext](net-ssl-SSLContext) val | [None](builtin-None) val) = reference
*   pipeline: [Bool](builtin-Bool) val = true

#### Returns

* [Client](net-http-Client) tag^

---

## Public Behaviours

### apply

Schedule a request.


```pony
be apply(
  request: Payload val)
```
#### Parameters

*   request: [Payload](net-http-Payload) val

---

### cancel

Cancel a request.


```pony
be cancel(
  request: Payload val)
```
#### Parameters

*   request: [Payload](net-http-Payload) val

---

## Private Functions

### _get_client

Gets or creates a client for the given URL.


```pony
fun ref _get_client(
  url: URL val)
: _ClientConnection tag ?
```
#### Parameters

*   url: [URL](net-http-URL) val

#### Returns

* [_ClientConnection](net-http-_ClientConnection) tag ?

---

